
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux内存管理2---段机制 / 憋错料</title>

    <meta name="description" content="Linux内存管理2---段机制 1.前言 本文所述关于内存管理的系列文章主要是对陈莉君老师所讲述的内存管理知识讲座的整理. 本讲座主要分三个主题展开对内存管理进行讲解:内存管理的硬件基础.虚拟地址空间的管理.物理地址空间的管理. 本文将主要以X86架构为例来介绍Linux内存管理的段机制. 2.段机制 段是虚拟地址空间的基本单位 段机制必须把虚拟地址空间的一个地址转换为线性地址空间的一个线性地址 可以从三个方面来描述段(如下图) 段的基地址(Base):在线性地址空间中段的起始地址: 段的界限(Limit):在虚拟地址空间中,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux内存管理2---段机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>1.前言</h1>
<p>本文所述关于内存管理的系列文章主要是对陈莉君老师所讲述的内存管理知识讲座的整理。</p>
<p>本讲座主要分三个主题展开对内存管理进行讲解：内存管理的硬件基础、虚拟地址空间的管理、物理地址空间的管理.</p>
<p>本文将主要以X86架构为例来介绍Linux内存管理的段机制。</p>
<h1>2.段机制</h1>
<ul>
<li>段是虚拟地址空间的基本单位</li>
</ul>
<ul>
<li>段机制必须把虚拟地址空间的一个地址转换为线性地址空间的一个线性地址</li>
</ul>
<ul>
<li>可以从三个方面来描述段（如下图）</li>
</ul>
<blockquote><p>段的基地址（Base）：在线性地址空间中段的起始地址；</p>
<p>段的界限（Limit）：在虚拟地址空间中，段内可以使用的最大偏移量；</p>
<p>段的保护属性：表示段的特性。例如该段是否可以被读出或写入。或者该段是否可以作为一个程序来执行，以及段的特权等级</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzExMzgxMTYvMjAxNzA3LzExMzgxMTYtMjAxNzA3MTUxNTAxMzA0MzEtMjA3ODU4OTcyOC5wbmc=.jpg"></p>
<p>图 段描述符的一般格式</p></blockquote>
<ul>
<li>段描述符表</li>
</ul>
<blockquote><p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzExMzgxMTYvMjAxNzA3LzExMzgxMTYtMjAxNzA3MTUxNTEwNDk5NzgtMTAwNjExMjAwNC5wbmc=.jpg"></p>
<p>图 段描述符表（段表）</p>
<p>段号描述虚拟地址空间段的编号；基地址是线性地址空间段的起始地址</p></blockquote>
<ul>
<li>保护模式下其它描述符表</li>
</ul>
<blockquote><p>全局描述符表（GDT）</p>
<p>中断描述符表（IDT）</p>
<p>局部描述符表（LDT）</p>
<p>注：为加快对如上描述符表的访问，intel为之设计了专门的寄存器，存放描述符表的基地址及表的长度界限</p></blockquote>
<ul>
<li>保护模式下的段寄存器</li>
</ul>
<blockquote><p>段寄存器存放段描述符表的索引（段号，也叫选择符），即从段描述符表中选择某个段.</p>
<p>其中:</p>
<p>索引（13位指明段号）；</p>
<p>TI(Table Index)指明使用全局描述符表还是局部描述符表；</p>
<p>RPL(Requestor Previlege Level)：2位指定4种特权级，用来决定内核态还是用户态</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzExMzgxMTYvMjAxNzA3LzExMzgxMTYtMjAxNzA3MTUxNTI4MTg1NzItOTUyNjk5MjUyLnBuZw==.jpg"></p>
<p>图 保护模式下的段寄存器</p></blockquote>
<ul>
<li>保护模式下的特权级</li>
</ul>
<blockquote><p>保护模式提供了四个特权级，用0~3四个数字表示</p>
<p>一般操作系统只使用了其中最低和最高两个，即0表示最高特权级，内核态；3表示最低特权级，用户态</p>
<p>保护模式规定高特权级可随意访问低特权级，低特权级不能随便访问高特权级</p></blockquote>
<ul>
<li>地址转换及保护</li>
</ul>
<blockquote><p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzExMzgxMTYvMjAxNzA3LzExMzgxMTYtMjAxNzA3MTUxNTUxMTU3NTktNTcyNTk3MjA1LnBuZw==.jpg"></p>
<p>图 地址转换</p>
<p>程序中的虚拟地址可以表示为“选择符：偏移量”这样的形式，通过以下步骤可以把一个虚拟地址转换为线性地址：</p>
<p>　　（1）在段寄存器中装入段选择符，同时把32位地址偏移量装入某个寄存器(比如ESI、EDI等)中。</p>
<p>　　（2）根据选择符中的索引值、TI及RPL值，再根据相应描述符表中的段基地址和段界限，进行一系列合法性检查(如特权级检查、界限检查)，如果该段无问题，就取出相应的描述符放入段描述符高速缓冲寄存器3中。</p>
<p>　　（3）将描述符中的32位段基地址和放在ESI、EDI等中的32位有效地址相加，就形成了32位线性地址。</p>
<p>　　注意，在上面的地址转换过程中，从两个方面对段进行了保护：</p>
<p>　　（1） 在一个段内，如果偏移量大于段界限，虚拟地址将没有意义，系统将产生异常。</p>
<p>　　（2） 如果要对一个段进行访问，系统会根据段的保护属性检查访问者是否具有访问权限，如果没有，则产生异常。例如，如果要在只读段中进行写入，系统将根据该段的属性检测到这是一种违规操作，则产生异常。</p></blockquote>
<h1>3.Linux如何处理段</h1>
<p>Linux将整个虚拟地址空间划分为一个段，段的基地址为0，段的界限为4G。</p>
<p>由于很多体系结构并不要求段机制必选，因此这样处理即使用了段机制又巧妙的化解了段机制</p>
<ul>
<li>IA32上设计操作系统时无法回避使用段机制</li>
</ul>
<blockquote><p>在IA32上任意给出的地址都是一个虚拟地址，即任意一个地址都是通过“选择符:偏移量”的方式给出的，这是段机制存访问模式的基本特点</p>
<p>所以在IA32上设计操作系统时无法回避使用段机制，IA32规定段机制是不可禁止的，因此不可能绕过它直接给出线性地址空间的地址</p>
<p>一个虚拟地址最终会通过“段基地址＋偏移量”的方式转化为一个线性地址</p></blockquote>
<ul>
<li>为何要绕过段机制</li>
</ul>
<blockquote><p>由于绝大多数硬件平台都不支持段机制，只支持分页机制，所以为了让Linux具有更好的可移植性，我们需要去掉段机制而只使用分页机制</p></blockquote>
<ul>
<li>Linux如何绕过段机制　</li>
</ul>
<blockquote><p>Linux的设计人员干脆让段的基地址为0，而段的界限为4GB，这时任意给出一个偏移量，则等式为“0+偏移量=线性地址”，也就是说“偏移量＝线性地址”。</p>
<p>另外由于段机制规定“偏移量 &lt;4GB”，所以偏移量的范围为0H～FFFFFFFFH，这恰好是线性地址空间范围，也就是说虚拟地址直接映射到了线性地址，</p>
<p>我们以后所提到的虚拟地址和线性地址指的也就是同一地址。</p>
<p>看来，Linux在没有回避段机制的情况下巧妙地把段机制给绕过去了。</p></blockquote>
<ul>
<li>Linux所必须创建哪些段　　</li>
</ul>
<blockquote><p>由于IA32段机制还规定，必须为代码段和数据段创建不同的段，所以Linux必须为代码段和数据段分别创建一个基地址为0，段界限为4GB的段描述符。</p>
<p>不仅如此，由于Linux内核运行在特权级0，而用户程序运行在特权级别3，根据IA32的段保护机制规定，特权级3的程序是无法访问特权级为0的段的，所以Linux必须为内核和用户程序分别创建其代码段和数据段。</p>
<p>这就意味着Linux必须创建4个段描述符——特权级0的代码段和数据段，特权级3的代码段和数据段。</p></blockquote>
<ul>
<li>Linux通过分页机制来保护内存　　</li>
</ul>
<blockquote><p>如果这么定义段，则上一节所说的段保护的第一个作用就失去了，因为这些段使用完全相同的线性地址空间（0～4GB），它们互相覆盖。</p>
<p>可以设想，如果不使用分页的话，线性地址空间直接被映射到物理空间，则你修改任何一个段的数据，都会同时修改其它段的数据</p>
<p>段机制所提供的通过“基地址：界限”方式本来将线性地址空间分割，以让段与段之间完全隔离，这种实现段保护的方式根本就不起作用了。</p>
<p>那么，这是不是意味着用户可以随意修改内核数据？显然不是的，这是因为，一方面用户段和内核段具有不同的特权级别，另一方面，Linux之所以这么定义段，正是为了实现一个纯的分页，而分页机制会提供给我们所需要的保护。</p></blockquote>
<h1>4.参考文献</h1>
<p>[1] Linux内存管理讲座PPT-陈莉君</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 05:20:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e9%9c%80%e8%a6%81/" title="需要">需要</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e5%ad%97/" title="数字">数字</a>, <a href="https://www.biecuoliao.com/tag/splay/" title="splay">splay</a>, <a href="https://www.biecuoliao.com/tag/%e8%ae%be%e8%ae%a1/" title="设计">设计</a>, <a href="https://www.biecuoliao.com/tag/%e5%86%85%e5%ad%98/" title="内存">内存</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%82%e8%80%83/" title="参考">参考</a>, <a href="https://www.biecuoliao.com/tag/%e6%a3%80%e6%b5%8b/" title="检测">检测</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%8b%e7%bb%8d/" title="介绍">介绍</a>, <a href="https://www.biecuoliao.com/tag/%e5%af%84%e5%ad%98%e5%99%a8/" title="寄存器">寄存器</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux内存管理2---段机制的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEj7BZ0.html" rel="bookmark">Linux内存管理3---分页机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 本文所述关于内存管理的系列文章主要是对陈莉君老师所讲述的内存管理知识讲座的整理. 本讲座主要分三个主题展开对内存管理进行讲解:内存管理的硬件基础.虚拟地址空间的管理.物理地址空间的管理. 本文将主要以X86架构为例来介绍Linux内存管理的分页机制. 2.分页机制 5. Linux中的汇编 6.Linux系统地址映射示例			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMykZn3.html" rel="bookmark">Linux内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.首先大概了解一下计算机CPU.Cache.内存.硬盘之间的关系及区别. 1.  CPU也称为中央处理器(CPU,Central Processing Unit)是一块超大规模的集成电路, 是一台计算机的运算核心(Core)和控制核心( Control Unit).它的功能主要是解释计算机指令以及处理计算机软件中的数据.中央处理器主要由三核心部件组成,运算器.控制器和总线(BUS),运算器又主要由算术逻辑单元(ALU)和寄存器(RS)组成. 2.Cache即高速缓冲存储器,是位于CPU与主内存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aYE5P0.html" rel="bookmark">浅谈Linux内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经常遇到一些刚接触Linux的新手会问内存占用怎么那么多? 在Linux中经常发现空闲内存很少,似乎所有的内存都被系统占用了,表面感觉是内存不够用了,其实不然.这是Linux内存管理的一个优秀特性,在这方面,区别于Windows的内存管理.主要特点是,无论物理内存有多大,Linux 都将其充份利用,将一些程序调用过的硬盘数据读入内存,利用内存读写的高速特性来提高Linux系统的数据访问性能.而Windows是只在需要内存时,才为应用程序分配内存,并不能充分利用大容量的内存空间.换句话说,每增加一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35m9NR3.html" rel="bookmark">&lbrack;转帖&rsqb;Linux分页机制之分页机制的演变--Linux内存管理&lpar;七&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux分页机制之分页机制的演变--Linux内存管理(七) 2016年09月01日 20:01:31 JeanCheng 阅读数:4543 https://blog.csdn.net/gatieme/article/details/52402967 ~ 版权声明:本文为博主原创文章 &amp;&amp; 转载请著名出处 @ http://blog.csdn.net/gatieme https://blog.csdn.net/gatieme/article/details/52402967 日期 内核版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xX1wB0.html" rel="bookmark">Linux内存管理机制简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Linux中经常发现空闲内存很少,似乎所有的内存都被系统占用了,表面感觉是内存不够用了,其实不然.这是Linux内存管理的一个优秀特性,区别于 Windows的内存管理. 主要特点是,无论物理内存有多大,Linux 都将其充份利用,将一些程序调用过的硬盘数据读入内存,利用内存读写的高速特性来提高Linux系统的数据访问性能.而Windows 是只在需要内存时,才为应用程序分配内存,并不能充分利用大容量的内存空间.换句话说,Linux自身的预分配内存机制使得主机上的物理内存会全部被用上.每增加一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/357r1XM.html" rel="bookmark">【研究任务】linux内存管理机制&mdash;&mdash;内核空间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux内存中线性地址为4G,0~3G为用户空间,3~4G为内核空间 一.      内核空间 内核空间是3~4G的内存地址,主要用来存储高优先级的代码 在X86结构中的内核地址存在三种类型的区域: ZONE_DMA     内存开始的16m ZONE_NORMAL       16m~896m ZONE_HIGHMEM    896M~ ZONE_DMA是DMA使用的页(DMA是直接路径访问,不经过cpu缓存而直接访问内存)ZONE_NORMAL是正常可寻址的页.ZONE_HIGHMEM是动			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/bMoY2k3.html" rel="bookmark">linux内存管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Linux 进程在内存中的数据结构 一个可执行程序在存储(没有调入内存)时分为代码段,数据段,未初始化数据段三部分:    1) 代码段:存放CPU执行的机器指令.通常代码区是共享的,即其它执行程序可调用它.假如机器中有数个进程运行相同的一个程序,那么它们就可以使用同一个代码段.     2) 数据段:存放已初始化的全局变量.静态变量(包括全局和局部的).常量.static全局变量和static函数只能在当前文件中被调用.     3) 未初始化数据区(uninitializeddata s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q5xW93.html" rel="bookmark">Linux内存管理 【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.chinaunix.net/uid-25909619-id-4491368.html Linux内存管理 摘要:本章首先以应用程序开发者的角度审视Linux的进程内存管理,在此基础上逐步深入到内核中讨论系统物理内存管理和内核内存的使用方法.力求从外到内.水到渠成地引导网友分析Linux的内存管理与使用.在本章最后,我们给出一个内存映射的实例,帮助网友们理解内核内存管理与用户内存管理之间的关系,希望大家最终能驾驭Linux内存管理. 前言 内存管理一向是所有操作系统书			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLa2p0.html" rel="bookmark">linux内存管理浅析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[地址映射](图:左中)linux内核使用页式内存管理,应用程序给出的内存地址是虚拟地址,它需要经过若干级页表一级一级的变换,才变成真正的物理地址.想一下,地址映射还是一件很恐怖的事情.当访问一个由虚拟地址表示的内存空间时,需要先经过若干次的内存访问,得到每一级页表中用于转换的页表项(页表是存放在内存里面的),才能完成映射.也就是说,要实现一次内存访问,实际上内存被访问了N+1次(N=页表级数),并且还需要做N次加法运算.所以,地址映射必须要有硬件支持,mmu(内存管理单元)就是这个硬件.并且需			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWwbE0.html" rel="bookmark" class="title">think in UML（二）</a>
					<div>
						基础篇——在学习中思考! 在大概了解了UML之后就该系统的学习UML的主要建模元素了,一个个实例帮助我们更好的理解这些元素的重要性并运用相关知识解决实际问题. 在UML里有一个概念叫版型,有些书里也称 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNg6n3.html" rel="bookmark" class="title">C&num;多线程实践&mdash;&mdash;提前释放锁</a>
					<div>
						一个被阻止的线程可以通过两种方式被提前释放: 使用Thread.Interrupt 使用Thread.Abort 释放一个线程的锁必须通过另外活动的线程实现,等待的线程自己是不能对它的被阻止状态做任何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gjBO0.html" rel="bookmark" class="title">oracle中动态SQL使用详细介绍</a>
					<div>
						Oracle编译PL/SQL程序块分为两个种:通常静态SQL采用前一种编译方式,而动态SQL采用后一种编译方式,需要了解的朋友可以参考下 1．静态SQLSQL与动态SQL Oracle编译PL/SQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Amm8a4.html" rel="bookmark" class="title">关于url</a>
					<div>
						URL即统一资源定位器用于定位万维网上的文档或其他数据,URL 可以由单词组成,比如 “www.baidu.com”,或者是因特网协议(IP)地址:192.168.x.xxx.大多数人在网上冲浪时,会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQDP53.html" rel="bookmark" class="title">为伊消得人憔悴--调试</a>
					<div>
						最近将Android开发环境更换为Android Studio,结果AVD总是无法启动.调了很长时间,出现了很多问题,最后还是解决了问题,启动了AVD. 在调试的过程中,出现了如下几个比较突出的问题: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myj7Xn0.html" rel="bookmark" class="title">Fork&sol;Join-Java并行计算框架</a>
					<div>
						Java在JDK7之后加入了并行计算的框架Fork/Join,可以解决我们系统中大数据计算的性能问题.Fork/Join采用的是分治法,Fork是将一个大任务拆分成若干个子任务,子任务分别去计算,而J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418Ano3.html" rel="bookmark" class="title">计蒜客--两数之和</a>
					<div>
						给定一个数组 number_inumber?i??,找到两个数,使得他们的和为一个给定的数值 targettarget. 其中:number[index_1] + number[index_2]==t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWYoyG3.html" rel="bookmark" class="title">Java实现验证码的制作</a>
					<div>
						验证码概述 为什么使用验证码? 验证码(CAPTCHA)是一种全自动程序.主要是为了区分“进行操作的是不是人”.如果没有验证码机制,将会导致以下的问题: 对特定网站不断进行登录,破解密码: 对某个网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWLwQG0.html" rel="bookmark" class="title">【转】千万别理程序员</a>
					<div>
						作者: Eric Wilson  来源: 外刊IT评论    原文链接 很多时候,我发现自己需要向编程界以外的人反复解释为什么随意的打搅一个编程中的程序员是多么的讨厌.我需要费力的向他们解释什么是‘流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVVbypM.html" rel="bookmark" class="title">public clas和class的区别</a>
					<div>
						*  一个java源文件中可以定义多个class public class K { public static void main(String[] args) { } } class A{ } cl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZlxr4.html" rel="bookmark" class="title">JavaScript基础--简单功能的计算器&lpar;十一&rpar;</a>
					<div>
						1 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mym8KAM.html" rel="bookmark" class="title">PowerShell技巧：使用XPath语法查询XML文件</a>
					<div>
						[TechTarget中国原创] XML是存储结构化数据的一个很好的途径,但是想要让数据在其中发挥作用又会有些困难.每一种语言都有其特定方式来查询XML文件中的命名空间.元素及属性.PowerShel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02yrkRM.html" rel="bookmark" class="title">冰盾DDoS防火墙</a>
					<div>
						★ 阻止DOS攻击        TearDrop.Land.Jolt.IGMP Nuker.Boink.Smurf.Bonk.BigPing.OOB等数百种. ★ 抵御DDOS攻击 SYN/ACK  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzxn74.html" rel="bookmark" class="title">Sqlserver中 登录用户只能看到自己拥有权限的库</a>
					<div>
						执行之前新建用户时不要赋予任何权限 USE master GO --将所有数据库的查看权限给Public角色,每个登录用户只能查看指定的数据库 --此语句会导致服务器上所有的用户在没有设置数据库权限的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezyxE3.html" rel="bookmark" class="title">【插头DP】BZOJ1187- &lbrack;HNOI2007&rsqb;神奇游乐园</a>
					<div>
						[题目大意] 在n*m的网格中选一条回路,使权值和最大. [思路] 和之前裸的插头DP差不多,只不过现在回路不需要经过所有的格子.所以有以下几个注意点(具体看注释): (1)left和up插头相等的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBQPo3.html" rel="bookmark" class="title">适配器模式 &colon; 农村小伙娶乌克兰美女语言不通 翻译软件立功</a>
					<div>
						不知道什么时候开始,总听到&quot; XXX 小伙娶乌克兰美女&quot; 的新闻,比如 农村小伙娶乌克兰美女语言不通 翻译软件立功 等等,我仔细地看了几篇新闻,发现居然不是标题党,新闻里的乌克兰妹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NaX14.html" rel="bookmark" class="title">python整理：IDE环境安装-pycharmn</a>
					<div>
						下载地址: http://www.jetbrains.com/pycharm/download/download-thanks.html?platform=windows 破解工具: idea.lan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeQpv0.html" rel="bookmark" class="title">java实现a&plus;b的多重输入</a>
					<div>
						import java.util.Scanner; public class hello { public static void main(String[] args) { Scanner cin  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jweGV3.html" rel="bookmark" class="title">leetcode链表--15、everse-nodes-in-k-group（按照k值进行k个结点的逆序）</a>
					<div>
						题目描述 Given a linked list, reverse the nodes of a linked list k at a time and return its modified lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QPVjl3.html" rel="bookmark" class="title">pat1044&period; Shopping in Mars &lpar;25&rpar;</a>
					<div>
						1044. Shopping in Mars (25) 时间限制 100 ms 内存限制 65536 kB 代码长度限制 16000 B 判题程序 Standard 作者 CHEN, Yue Shop ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
